package com.hai.dao;

import com.hai.entity.HighDiscountAgentBatch;
import com.hai.entity.HighDiscountAgentBatchExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighDiscountAgentBatchMapper extends HighDiscountAgentBatchMapperExt {
    @SelectProvider(type=HighDiscountAgentBatchSqlProvider.class, method="countByExample")
    long countByExample(HighDiscountAgentBatchExample example);

    @DeleteProvider(type=HighDiscountAgentBatchSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighDiscountAgentBatchExample example);

    @Delete({
        "delete from high_discount_agent_batch",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_discount_agent_batch (discount_agent_id, discount_id, ",
        "discount_name, discount_price, ",
        "using_range, use_scope, ",
        "agent_id, batch_identifier, ",
        "batch_num, code_start, ",
        "code_end, mail_time, ",
        "create_time, `status`, ",
        "qr_code, ext_1, ext_2, ",
        "ext_3)",
        "values (#{discountAgentId,jdbcType=BIGINT}, #{discountId,jdbcType=BIGINT}, ",
        "#{discountName,jdbcType=VARCHAR}, #{discountPrice,jdbcType=DECIMAL}, ",
        "#{usingRange,jdbcType=INTEGER}, #{useScope,jdbcType=INTEGER}, ",
        "#{agentId,jdbcType=BIGINT}, #{batchIdentifier,jdbcType=VARCHAR}, ",
        "#{batchNum,jdbcType=INTEGER}, #{codeStart,jdbcType=VARCHAR}, ",
        "#{codeEnd,jdbcType=VARCHAR}, #{mailTime,jdbcType=TIMESTAMP}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{qrCode,jdbcType=VARCHAR}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighDiscountAgentBatch record);

    @InsertProvider(type=HighDiscountAgentBatchSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighDiscountAgentBatch record);

    @SelectProvider(type=HighDiscountAgentBatchSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_agent_id", property="discountAgentId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_name", property="discountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="using_range", property="usingRange", jdbcType=JdbcType.INTEGER),
        @Result(column="use_scope", property="useScope", jdbcType=JdbcType.INTEGER),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="batch_identifier", property="batchIdentifier", jdbcType=JdbcType.VARCHAR),
        @Result(column="batch_num", property="batchNum", jdbcType=JdbcType.INTEGER),
        @Result(column="code_start", property="codeStart", jdbcType=JdbcType.VARCHAR),
        @Result(column="code_end", property="codeEnd", jdbcType=JdbcType.VARCHAR),
        @Result(column="mail_time", property="mailTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="qr_code", property="qrCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighDiscountAgentBatch> selectByExample(HighDiscountAgentBatchExample example);

    @Select({
        "select",
        "id, discount_agent_id, discount_id, discount_name, discount_price, using_range, ",
        "use_scope, agent_id, batch_identifier, batch_num, code_start, code_end, mail_time, ",
        "create_time, `status`, qr_code, ext_1, ext_2, ext_3",
        "from high_discount_agent_batch",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_agent_id", property="discountAgentId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_name", property="discountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="using_range", property="usingRange", jdbcType=JdbcType.INTEGER),
        @Result(column="use_scope", property="useScope", jdbcType=JdbcType.INTEGER),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="batch_identifier", property="batchIdentifier", jdbcType=JdbcType.VARCHAR),
        @Result(column="batch_num", property="batchNum", jdbcType=JdbcType.INTEGER),
        @Result(column="code_start", property="codeStart", jdbcType=JdbcType.VARCHAR),
        @Result(column="code_end", property="codeEnd", jdbcType=JdbcType.VARCHAR),
        @Result(column="mail_time", property="mailTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="qr_code", property="qrCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighDiscountAgentBatch selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighDiscountAgentBatchSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighDiscountAgentBatch record, @Param("example") HighDiscountAgentBatchExample example);

    @UpdateProvider(type=HighDiscountAgentBatchSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighDiscountAgentBatch record, @Param("example") HighDiscountAgentBatchExample example);

    @UpdateProvider(type=HighDiscountAgentBatchSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighDiscountAgentBatch record);

    @Update({
        "update high_discount_agent_batch",
        "set discount_agent_id = #{discountAgentId,jdbcType=BIGINT},",
          "discount_id = #{discountId,jdbcType=BIGINT},",
          "discount_name = #{discountName,jdbcType=VARCHAR},",
          "discount_price = #{discountPrice,jdbcType=DECIMAL},",
          "using_range = #{usingRange,jdbcType=INTEGER},",
          "use_scope = #{useScope,jdbcType=INTEGER},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "batch_identifier = #{batchIdentifier,jdbcType=VARCHAR},",
          "batch_num = #{batchNum,jdbcType=INTEGER},",
          "code_start = #{codeStart,jdbcType=VARCHAR},",
          "code_end = #{codeEnd,jdbcType=VARCHAR},",
          "mail_time = #{mailTime,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "qr_code = #{qrCode,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighDiscountAgentBatch record);
}