package com.hai.dao;

import com.hai.entity.HighDiscountAgentBatch;
import com.hai.entity.HighDiscountAgentBatchExample.Criteria;
import com.hai.entity.HighDiscountAgentBatchExample.Criterion;
import com.hai.entity.HighDiscountAgentBatchExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighDiscountAgentBatchSqlProvider {

    public String countByExample(HighDiscountAgentBatchExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_discount_agent_batch");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighDiscountAgentBatchExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_discount_agent_batch");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighDiscountAgentBatch record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_discount_agent_batch");
        
        if (record.getDiscountAgentId() != null) {
            sql.VALUES("discount_agent_id", "#{discountAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountId() != null) {
            sql.VALUES("discount_id", "#{discountId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountName() != null) {
            sql.VALUES("discount_name", "#{discountName,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPrice() != null) {
            sql.VALUES("discount_price", "#{discountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getUsingRange() != null) {
            sql.VALUES("using_range", "#{usingRange,jdbcType=INTEGER}");
        }
        
        if (record.getUseScope() != null) {
            sql.VALUES("use_scope", "#{useScope,jdbcType=INTEGER}");
        }
        
        if (record.getAgentId() != null) {
            sql.VALUES("agent_id", "#{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getBatchIdentifier() != null) {
            sql.VALUES("batch_identifier", "#{batchIdentifier,jdbcType=VARCHAR}");
        }
        
        if (record.getBatchNum() != null) {
            sql.VALUES("batch_num", "#{batchNum,jdbcType=INTEGER}");
        }
        
        if (record.getCodeStart() != null) {
            sql.VALUES("code_start", "#{codeStart,jdbcType=VARCHAR}");
        }
        
        if (record.getCodeEnd() != null) {
            sql.VALUES("code_end", "#{codeEnd,jdbcType=VARCHAR}");
        }
        
        if (record.getMailTime() != null) {
            sql.VALUES("mail_time", "#{mailTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getQrCode() != null) {
            sql.VALUES("qr_code", "#{qrCode,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighDiscountAgentBatchExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("discount_agent_id");
        sql.SELECT("discount_id");
        sql.SELECT("discount_name");
        sql.SELECT("discount_price");
        sql.SELECT("using_range");
        sql.SELECT("use_scope");
        sql.SELECT("agent_id");
        sql.SELECT("batch_identifier");
        sql.SELECT("batch_num");
        sql.SELECT("code_start");
        sql.SELECT("code_end");
        sql.SELECT("mail_time");
        sql.SELECT("create_time");
        sql.SELECT("`status`");
        sql.SELECT("qr_code");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_discount_agent_batch");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighDiscountAgentBatch record = (HighDiscountAgentBatch) parameter.get("record");
        HighDiscountAgentBatchExample example = (HighDiscountAgentBatchExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_discount_agent_batch");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountAgentId() != null) {
            sql.SET("discount_agent_id = #{record.discountAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountId() != null) {
            sql.SET("discount_id = #{record.discountId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountName() != null) {
            sql.SET("discount_name = #{record.discountName,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPrice() != null) {
            sql.SET("discount_price = #{record.discountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getUsingRange() != null) {
            sql.SET("using_range = #{record.usingRange,jdbcType=INTEGER}");
        }
        
        if (record.getUseScope() != null) {
            sql.SET("use_scope = #{record.useScope,jdbcType=INTEGER}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        }
        
        if (record.getBatchIdentifier() != null) {
            sql.SET("batch_identifier = #{record.batchIdentifier,jdbcType=VARCHAR}");
        }
        
        if (record.getBatchNum() != null) {
            sql.SET("batch_num = #{record.batchNum,jdbcType=INTEGER}");
        }
        
        if (record.getCodeStart() != null) {
            sql.SET("code_start = #{record.codeStart,jdbcType=VARCHAR}");
        }
        
        if (record.getCodeEnd() != null) {
            sql.SET("code_end = #{record.codeEnd,jdbcType=VARCHAR}");
        }
        
        if (record.getMailTime() != null) {
            sql.SET("mail_time = #{record.mailTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getQrCode() != null) {
            sql.SET("qr_code = #{record.qrCode,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_discount_agent_batch");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("discount_agent_id = #{record.discountAgentId,jdbcType=BIGINT}");
        sql.SET("discount_id = #{record.discountId,jdbcType=BIGINT}");
        sql.SET("discount_name = #{record.discountName,jdbcType=VARCHAR}");
        sql.SET("discount_price = #{record.discountPrice,jdbcType=DECIMAL}");
        sql.SET("using_range = #{record.usingRange,jdbcType=INTEGER}");
        sql.SET("use_scope = #{record.useScope,jdbcType=INTEGER}");
        sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        sql.SET("batch_identifier = #{record.batchIdentifier,jdbcType=VARCHAR}");
        sql.SET("batch_num = #{record.batchNum,jdbcType=INTEGER}");
        sql.SET("code_start = #{record.codeStart,jdbcType=VARCHAR}");
        sql.SET("code_end = #{record.codeEnd,jdbcType=VARCHAR}");
        sql.SET("mail_time = #{record.mailTime,jdbcType=TIMESTAMP}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("qr_code = #{record.qrCode,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighDiscountAgentBatchExample example = (HighDiscountAgentBatchExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighDiscountAgentBatch record) {
        SQL sql = new SQL();
        sql.UPDATE("high_discount_agent_batch");
        
        if (record.getDiscountAgentId() != null) {
            sql.SET("discount_agent_id = #{discountAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountId() != null) {
            sql.SET("discount_id = #{discountId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountName() != null) {
            sql.SET("discount_name = #{discountName,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPrice() != null) {
            sql.SET("discount_price = #{discountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getUsingRange() != null) {
            sql.SET("using_range = #{usingRange,jdbcType=INTEGER}");
        }
        
        if (record.getUseScope() != null) {
            sql.SET("use_scope = #{useScope,jdbcType=INTEGER}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getBatchIdentifier() != null) {
            sql.SET("batch_identifier = #{batchIdentifier,jdbcType=VARCHAR}");
        }
        
        if (record.getBatchNum() != null) {
            sql.SET("batch_num = #{batchNum,jdbcType=INTEGER}");
        }
        
        if (record.getCodeStart() != null) {
            sql.SET("code_start = #{codeStart,jdbcType=VARCHAR}");
        }
        
        if (record.getCodeEnd() != null) {
            sql.SET("code_end = #{codeEnd,jdbcType=VARCHAR}");
        }
        
        if (record.getMailTime() != null) {
            sql.SET("mail_time = #{mailTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getQrCode() != null) {
            sql.SET("qr_code = #{qrCode,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighDiscountAgentBatchExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}