package com.hai.dao;

import com.hai.entity.HighDiscountAgentCode;
import com.hai.entity.HighDiscountAgentCodeExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighDiscountAgentCodeMapper extends HighDiscountAgentCodeMapperExt {
    @SelectProvider(type=HighDiscountAgentCodeSqlProvider.class, method="countByExample")
    long countByExample(HighDiscountAgentCodeExample example);

    @DeleteProvider(type=HighDiscountAgentCodeSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighDiscountAgentCodeExample example);

    @Delete({
        "delete from high_discount_agent_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_discount_agent_code (discount_agent_id, discount_agent_batch_id, ",
        "qr_code, create_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{discountAgentId,jdbcType=BIGINT}, #{discountAgentBatchId,jdbcType=BIGINT}, ",
        "#{qrCode,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighDiscountAgentCode record);

    @InsertProvider(type=HighDiscountAgentCodeSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighDiscountAgentCode record);

    @SelectProvider(type=HighDiscountAgentCodeSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_agent_id", property="discountAgentId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_agent_batch_id", property="discountAgentBatchId", jdbcType=JdbcType.BIGINT),
        @Result(column="qr_code", property="qrCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighDiscountAgentCode> selectByExample(HighDiscountAgentCodeExample example);

    @Select({
        "select",
        "id, discount_agent_id, discount_agent_batch_id, qr_code, create_time, `status`, ",
        "ext_1, ext_2, ext_3",
        "from high_discount_agent_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_agent_id", property="discountAgentId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_agent_batch_id", property="discountAgentBatchId", jdbcType=JdbcType.BIGINT),
        @Result(column="qr_code", property="qrCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighDiscountAgentCode selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighDiscountAgentCodeSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighDiscountAgentCode record, @Param("example") HighDiscountAgentCodeExample example);

    @UpdateProvider(type=HighDiscountAgentCodeSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighDiscountAgentCode record, @Param("example") HighDiscountAgentCodeExample example);

    @UpdateProvider(type=HighDiscountAgentCodeSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighDiscountAgentCode record);

    @Update({
        "update high_discount_agent_code",
        "set discount_agent_id = #{discountAgentId,jdbcType=BIGINT},",
          "discount_agent_batch_id = #{discountAgentBatchId,jdbcType=BIGINT},",
          "qr_code = #{qrCode,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighDiscountAgentCode record);
}