package com.hai.dao;

import com.hai.entity.HighGoodsType;
import com.hai.entity.HighGoodsTypeExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighGoodsTypeMapper extends HighGoodsTypeMapperExt {
    @SelectProvider(type=HighGoodsTypeSqlProvider.class, method="countByExample")
    long countByExample(HighGoodsTypeExample example);

    @DeleteProvider(type=HighGoodsTypeSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighGoodsTypeExample example);

    @Delete({
        "delete from high_goods_type",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int deleteByPrimaryKey(Integer id);

    @Insert({
        "insert into high_goods_type (parent_id, company_id, ",
        "title, business_type, ",
        "user_service, img, ",
        "created_user_id, created_time, ",
        "updated_user_id, updated_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{parentId,jdbcType=INTEGER}, #{companyId,jdbcType=BIGINT}, ",
        "#{title,jdbcType=VARCHAR}, #{businessType,jdbcType=INTEGER}, ",
        "#{userService,jdbcType=VARCHAR}, #{img,jdbcType=VARCHAR}, ",
        "#{createdUserId,jdbcType=INTEGER}, #{createdTime,jdbcType=TIMESTAMP}, ",
        "#{updatedUserId,jdbcType=INTEGER}, #{updatedTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighGoodsType record);

    @InsertProvider(type=HighGoodsTypeSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighGoodsType record);

    @SelectProvider(type=HighGoodsTypeSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="parent_id", property="parentId", jdbcType=JdbcType.INTEGER),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="title", property="title", jdbcType=JdbcType.VARCHAR),
        @Result(column="business_type", property="businessType", jdbcType=JdbcType.INTEGER),
        @Result(column="user_service", property="userService", jdbcType=JdbcType.VARCHAR),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="updated_user_id", property="updatedUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="updated_time", property="updatedTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighGoodsType> selectByExample(HighGoodsTypeExample example);

    @Select({
        "select",
        "id, parent_id, company_id, title, business_type, user_service, img, created_user_id, ",
        "created_time, updated_user_id, updated_time, `status`, ext_1, ext_2, ext_3",
        "from high_goods_type",
        "where id = #{id,jdbcType=INTEGER}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="parent_id", property="parentId", jdbcType=JdbcType.INTEGER),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="title", property="title", jdbcType=JdbcType.VARCHAR),
        @Result(column="business_type", property="businessType", jdbcType=JdbcType.INTEGER),
        @Result(column="user_service", property="userService", jdbcType=JdbcType.VARCHAR),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="updated_user_id", property="updatedUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="updated_time", property="updatedTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighGoodsType selectByPrimaryKey(Integer id);

    @UpdateProvider(type=HighGoodsTypeSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighGoodsType record, @Param("example") HighGoodsTypeExample example);

    @UpdateProvider(type=HighGoodsTypeSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighGoodsType record, @Param("example") HighGoodsTypeExample example);

    @UpdateProvider(type=HighGoodsTypeSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighGoodsType record);

    @Update({
        "update high_goods_type",
        "set parent_id = #{parentId,jdbcType=INTEGER},",
          "company_id = #{companyId,jdbcType=BIGINT},",
          "title = #{title,jdbcType=VARCHAR},",
          "business_type = #{businessType,jdbcType=INTEGER},",
          "user_service = #{userService,jdbcType=VARCHAR},",
          "img = #{img,jdbcType=VARCHAR},",
          "created_user_id = #{createdUserId,jdbcType=INTEGER},",
          "created_time = #{createdTime,jdbcType=TIMESTAMP},",
          "updated_user_id = #{updatedUserId,jdbcType=INTEGER},",
          "updated_time = #{updatedTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int updateByPrimaryKey(HighGoodsType record);
}