package com.hai.service;

import com.hai.entity.HighActivityInfo;
import com.hai.entity.HighActivityPartakeRule;
import com.hai.entity.HighDiscountPackageAgentRecord;
import com.hai.entity.HighDiscountPackageAgentRel;

import java.util.List;
import java.util.Map;

/**
 * @serviceName .java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // 优惠券包代理商业务
 * @createTime 10:50 2023/9/20
 **/
public interface HighDiscountPackageAgentService {

    /**
    * @Author Sum1Dream
    * @Name insertDiscountPackageAgent
    * @Description // 新增优惠券包代理商关联
    * @Date 10:52 2023/9/20
    * @Param discountPackageAgentRel
     * @return void
    */
    void insertDiscountPackageAgentRel(HighDiscountPackageAgentRel discountPackageAgentRel);

    /**
    * @Author Sum1Dream
    * @Name updateDiscountPackageAgentRel
    * @Description // 更新优惠券包代理商关联
    * @Date 10:53 2023/9/20
    * @Param discountPackageAgentRel
     * @return void
    */
    void updateDiscountPackageAgentRel(HighDiscountPackageAgentRel discountPackageAgentRel);

    /**
    * @Author Sum1Dream
    * @Name getDetailRelById
    * @Description // 根据id查询优惠券包代理商关联详情
    * @Date 10:53 2023/9/20
    * @Param id
     * @return com.hai.entity.HighDiscountPackageAgentRel
    */
    HighDiscountPackageAgentRel getDetailRelById(Long id);

    /**
    * @Author Sum1Dream
    * @Name getDetailRelByMap
    * @Description //根据map查询优惠券包代理商关联详情
    * @Date 15:13 2023/9/20
    * @Param map
     * @return com.hai.entity.HighDiscountPackageAgentRel
    */
    HighDiscountPackageAgentRel getDetailRelByMap(Map<String , Object> map);

    /**
    * @Author Sum1Dream
    * @Name getListRel
    * @Description // 查询列表
    * @Date 11:27 2023/9/20 
    * @Param param  
     * @return java.util.List<com.hai.entity.HighDiscountPackageAgentRel>
    */
    List<HighDiscountPackageAgentRel> getListRel(Map<String, Object> param);

    /**
    * @Author Sum1Dream
    * @Name insertDiscountPackageAgentRecord
    * @Description // 插入优惠券包代理商分发记录
    * @Date 13:53 2023/9/20
    * @Param discountPackageAgentRecord
     * @return void
    */
    void insertDiscountPackageAgentRecord(HighDiscountPackageAgentRecord discountPackageAgentRecord);

    /**
    * @Author Sum1Dream
    * @Name updateDiscountPackageAgentRecord
    * @Description //更新优惠券包代理商分发记录
    * @Date 13:55 2023/9/20
    * @Param discountPackageAgentRecord
     * @return void
    */
    void updateDiscountPackageAgentRecord(HighDiscountPackageAgentRecord discountPackageAgentRecord);

    /**
    * @Author Sum1Dream
    * @Name getDetailRecordById
    * @Description // 根据id 查询优惠券包代理商分发记录
    * @Date 13:55 2023/9/20
    * @Param id
     * @return com.hai.entity.HighDiscountPackageAgentRecord
    */
    HighDiscountPackageAgentRecord getDetailRecordById(Long id);

    /**
    * @Author Sum1Dream
    * @Name getDetailRecordByMap
    * @Description // 根据map 查询优惠券包代理商分发记录
    * @Date 15:13 2023/9/20
    * @Param map
     * @return com.hai.entity.HighDiscountPackageAgentRecord
    */
    HighDiscountPackageAgentRecord getDetailRecordByMap(Map<String , Object> map);

    /**
    * @Author Sum1Dream
    * @Name getListRecord
    * @Description // 查询列表
    * @Date 13:59 2023/9/20
    * @Param param
     * @return java.util.List<com.hai.entity.HighDiscountPackageAgentRecord>
    */
    List<HighDiscountPackageAgentRecord> getListRecord(Map<String, Object> param);

}
