package com.hai.service.impl;

import com.hai.dao.HighDiscountPackageAgentRecordMapper;
import com.hai.dao.HighDiscountPackageAgentRelMapper;
import com.hai.entity.*;
import com.hai.service.HighDiscountPackageAgentService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service("highDiscountPackageAgentService")
public class HighDiscountPackageAgentServiceImpl implements HighDiscountPackageAgentService {

    @Resource
    private HighDiscountPackageAgentRecordMapper discountPackageAgentRecordMapper;

    @Resource
    private HighDiscountPackageAgentRelMapper discountPackageAgentRelMapper;

    @Override
    public void insertDiscountPackageAgentRel(HighDiscountPackageAgentRel discountPackageAgentRel) {
        discountPackageAgentRelMapper.insert(discountPackageAgentRel);
    }

    @Override
    public void updateDiscountPackageAgentRel(HighDiscountPackageAgentRel discountPackageAgentRel) {
        discountPackageAgentRelMapper.updateByPrimaryKey(discountPackageAgentRel);
    }

    @Override
    public HighDiscountPackageAgentRel getDetailRelById(Long id) {
        return discountPackageAgentRelMapper.selectByPrimaryKey(id);
    }

    @Override
    public HighDiscountPackageAgentRel getDetailRelByMap(Map<String, Object> map) {

        HighDiscountPackageAgentRelExample example = new HighDiscountPackageAgentRelExample();
        HighDiscountPackageAgentRelExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(map, "agentId") != null) {
            criteria.andAgentIdEqualTo(MapUtils.getLong(map, "agentId"));
        }
        if (MapUtils.getLong(map, "discountPackageId") != null) {
            criteria.andDiscountPackageIdEqualTo(MapUtils.getLong(map, "discountPackageId"));
        }

        List<HighDiscountPackageAgentRel> list = discountPackageAgentRelMapper.selectByExample(example);

        if (list.size() > 0) {
            return list.get(0);
        }

        return null;
    }

    @Override
    public List<HighDiscountPackageAgentRel> getListRel(Map<String, Object> param) {

        HighDiscountPackageAgentRelExample example = new HighDiscountPackageAgentRelExample();
        HighDiscountPackageAgentRelExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(param, "agentId") != null) {
            criteria.andAgentIdEqualTo(MapUtils.getLong(param, "agentId"));
        }

        return discountPackageAgentRelMapper.selectByExample(example);
    }

    @Override
    public void insertDiscountPackageAgentRecord(HighDiscountPackageAgentRecord discountPackageAgentRecord) {
        discountPackageAgentRecordMapper.insert(discountPackageAgentRecord);
    }

    @Override
    public void updateDiscountPackageAgentRecord(HighDiscountPackageAgentRecord discountPackageAgentRecord) {
        discountPackageAgentRecordMapper.updateByPrimaryKey(discountPackageAgentRecord);
    }

    @Override
    public HighDiscountPackageAgentRecord getDetailRecordById(Long id) {
        return discountPackageAgentRecordMapper.selectByPrimaryKey(id);
    }

    @Override
    public HighDiscountPackageAgentRecord getDetailRecordByMap(Map<String, Object> map) {
        return null;
    }

    @Override
    public List<HighDiscountPackageAgentRecord> getListRecord(Map<String, Object> param) {

        HighDiscountPackageAgentRecordExample example = new HighDiscountPackageAgentRecordExample();
        HighDiscountPackageAgentRecordExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(param, "agentId") != null) {
            criteria.andAgentIdEqualTo(MapUtils.getLong(param, "agentId"));
        }
        if (MapUtils.getLong(param, "discountPackageId") != null) {
            criteria.andDiscountPackageIdEqualTo(MapUtils.getLong(param, "discountPackageId"));
        }

        return discountPackageAgentRecordMapper.selectByExample(example);
    }
}
